// location variables to pass to PHP script and update in database
var latitude;
var longitude;

// flag to change the_data that is passed to PHP script
// the_data = username and password for authorization when flag is false
// the_data = username, password, latitude and longitude for db update
var userAuthFlag=false;

// create the XMLHttpRequest object, according browser
function get_XmlHttp() {
  // create the variable that will contain the instance of the XMLHttpRequest object (initially with null value)
  var xmlHttp = null;

  if(window.XMLHttpRequest) {		// for Forefox, IE7+, Opera, Safari, ...
    xmlHttp = new XMLHttpRequest();
  }
  else if(window.ActiveXObject) {	// for Internet Explorer 5 or 6
    xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
  }

  return xmlHttp;
}

function updateLocation () {
	// get current location and call either the success or error functions 
	navigator.geolocation.getCurrentPosition(onSuccess, onError);
	}

// onSuccess store latitutde and longitude and update in DB
function onSuccess(position) {
    // store the location in global variables
    latitude = position.coords.latitude;
    longitude = position.coords.longitude;
    
    // call PHP script to update location
    ajaxrequest('http://geoapps.rc.rit.edu/talha/servlets/dbupdate.php')
    
    // vibrate for 2 seconds to indicate successful update
    navigator.notification.vibrate(2000); 
        
    // wait for 30 minutes and then call updateLocation again
    setInterval('updateLocation()',(1000*60*30)); // second x minute x 30 minutes - 1800000
}

// onError display error message that we are unable to get location
// but we will try to get location again in 30 mins and update the DB
function onError(error) {
    alert('code: '    + error.code    + '\n' +
          'message: ' + error.message + '\n Will try in 30 minutes to get location again');
    
    
 // wait for 30 minutes and then call updateLocation again
    setInterval('updateLocation()',(1000*60*30));
}

// sends data to a php file, via POST, and displays the received answer
// the password is encrypted using sha1 before sending it by POST
function ajaxrequest(php_file) {
  var request =  get_XmlHttp();		// call the function for the XMLHttpRequest instance

  // create pairs index=value with data that must be sent to server
  if (!userAuthFlag) { // for user authorization set the_data as below
  var  the_data = 'username='+document.getElementById('username').value +'&password='+ Sha1.hash(document.getElementById('password').value);
  }
  else { // for DB update include latitude and longitude as well
	  var  the_data = 'username='+document.getElementById('username').value +'&password='+ Sha1.hash(document.getElementById('password').value) +'&latitude=' +latitude +'&longitude='+longitude;
  }

  request.open("POST", php_file, true);			// set the request

  // adds  a header to tell the PHP script to recognize the data as is sent via POST
  request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  request.send(the_data);		// calls the send() method with data as parameter

  
  if (!userAuthFlag) { // check reponse only for user authorization
  // Check request status
  // If the response is received completely display message for user authorization
  // success or fail
  request.onreadystatechange = function() {

// do this when we get a response from the php script
    if (request.readyState == 4) {
       	var auth_response = request.responseText;
    	
       	// if success message is received display alert and update userAuthflag
       	// and call update location function
    	if ( auth_response.match(/pass.*/) ) {
    		alert("Success!\n\nYour username and password will now be stored.\n\n" +
			      "Your location will now tracked and will be updated in " +
			      "the database\nevery 30 minutes");	
    		
    		// set user authflag to true to change the_data value
    		userAuthFlag = true;
    		
    		// call update location
    		updateLocation();
    	}
    	else {
    		alert("Incorrect username/password");
    		
    	}
      } // if to check ready state = 4 ends
    }// onreadystatechange function ends
  } // if to check response for user authorization ends 
} // ajax request function ends
